;;;
;;; ޷νϤ JavaScript & HTML եȤƽϤץ
;;;                                                         by T.Komiya
;;;
;;; ջࡧ
;;;   1. ֥饦JavaScriptѲǽǤʤȤޤ
;;;   2. HTML  <canvas> 򥵥ݡȤ֥饦ǤʤȤޤ
;;;      Safari 2, Firefox 1.5, Opera 9б
;;;

;; 桼
;(define *canvas-html-directory* "~/Desktop/html-picl")
(define *canvas-html-directory* #f) ; current directory
;(define *output-directory* *canvas-html-directory*)
(define *output-directory* #f)
(define *output-base-filename* "output")

;;

(define (complete-path ext)
  (string-append (if *output-directory*
                     (string-append *output-directory* "/")
                     "")
                 *output-base-filename* ext))

(define *output-js-file* (complete-path ".js"))
(define *output-html-file* (complete-path ".html"))

(define *image-file* #f)

(define (load-path f)
  (string-append (if *canvas-html-directory*
                     (string-append *canvas-html-directory* "/")
                     "")
                 f))

(load (load-path "picl.lsp"))
(load (load-path "picl-test.lsp"))

(define :height ':height)
(define :width ':width)
(define :fill ':fill)
(define :smooth ':smooth)
(define :splinesteps ':splinesteps)

(define (pack . args) #t)
(define (tk:update) #t)

(define (->str c)
  (if (symbol? c)
      (symbol->string c)
      c))

(define (output-html)
  (format #t "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\">~%")
  (format #t "<html>~%")
  (format #t "  <head>~%")
  (format #t "    <style type=\"text/css\">~%")
  (format #t "      canvas {~%")
  (format #t "        border: 1px solid #aaaaaa;~%")
  (format #t "      }~%")
  (format #t "    </style>~%")
  (format #t "  </head>~%")
  (format #t "  <script type=\"text/javascript\" src=\"~a\"></script>~%"
          (string-append *output-base-filename* ".js"))
  (format #t "  <body onload=\"draw()\">~%")
;  (format #t "    <div ~%")
  (format #t "    <canvas id=\"canvas\" width=\"~a\" height=\"~a\"></canvas>~%"
          (ceiling *canvas-w*) (ceiling *canvas-h*))
  (if *image-file*
      (format #t "    <img id=\"imgsrc\" src=\"~a\" style=\"visibility:hidden\">~%"
              *image-file*))
  (format #t "  </body>~%")
  (format #t "</html>~%"))

(define (output-js-pre)
  (format #t "function draw(vals) {~%")
  (format #t "  var canvas = document.getElementById(\"canvas\");~%")
  (format #t "  var ctx = canvas.getContext(\"2d\");~%")
  (format #t "  ctx.strokeStyle = ~s;~%" (->str *line-color*))
  (format #t "  ctx.fillStyle = ~s;~%" (->str *bg-color*))
  (format #t "  ctx.fillRect(0, 0, ~a, ~a);~%"
          (ceiling *canvas-w*)
          (ceiling *canvas-h*))
  (if *image-file*
      (begin
        (format #t "  imgObj = new Image();~%")
        (format #t "  imgObj.src = \"~a\";~%" *image-file*)))
  (format #t "  with (ctx) {~%"))

(define (output-js-post)
  (format #t "  }~%")
  (format #t "}"))

(define (emit fmt . args)
  (apply format #t (format #f "    ~a~%" fmt) args))

(define (emit_ fmt . args) (apply format #t fmt args))

(define (redirect-aux filename thunk)
  (let ((port (open-output-file filename)))
    (with-output-to-port port thunk)
    (close-output-port port)))

(macro (out form)
  `(dlet ,(if (null? (cddr form))
              '()
              `((*output-base-filename* ,(caddr form))))
     (dlet ,(if (null? (cddr form))
                '()
                `((*output-js-file* (complete-path ".js"))
                  (*output-html-file* (complete-path ".html"))))
       (redirect-aux *output-js-file*
                     (lambda () (output-js-pre) ,(cadr form) (output-js-post)))
       (redirect-aux *output-html-file* (lambda () (output-html))))))

(define (canvas name . args)
  (define (canvas-obj command kind . rest)
    (case command
      ((create)
       (case kind
         ((line)
          (emit "beginPath();")
          (emit "moveTo(~a, ~a);" (car rest) (cadr rest))
          (emit "lineTo(~a, ~a);" (caddr rest) (cadddr rest))
          (emit "closePath();")
          (emit "stroke();"))
         ((polygon)
          (cond ((memq :fill rest)
                 => (lambda (x) (emit "fillStyle = ~s;" (->str (cadr x))))))
          (emit "beginPath();")
          (emit "moveTo(~a, ~a);" (car rest) (cadr rest))
          (let loop ((x (cddr rest)))
            (if (or (null? x)
                    (symbol? (car x))) ; ʹߤ:fillΥץ
                (begin
                  (emit "closePath();")
                  (emit "fill();"))
                (begin
                  (emit "lineTo(~a, ~a);" (car x) (cadr x))
                  (loop (cddr x))))))))
      (else
       (error "Unknown command for canvas objects: ~a" command))))
  (eval `(define ,name ,canvas-obj)))

;; JavaScriptǽ񤤤ץफpainterؿ
;; JavaScriptץʸͿ
;; աsegmetns->paintervects->painterȰۤʤꡤEdge1xEdge2y
;;       ʿԤʥե졼ˤΤбǽ
(define (js-painter str)
  (lambda (frame)
    (let* ((p ((frame-coord-map frame) (make-vect 0 0)))
           (q ((frame-coord-map frame) (make-vect 1 1)))
           (fw (- (xcor-vect q) (xcor-vect p)))
           (fh (- (ycor-vect q) (ycor-vect p))))
      (emit "save();")
      (emit "translate(~a, ~a);" (* (xcor-vect p) *frame-scale*)
                                 (- *canvas-h* (* (ycor-vect q) *frame-scale*)))
      (emit "scale(~a, ~a);" fw fh)
      (emit str)
      (emit "restore();"))))

(define (js-painter2 thunk)
  (lambda (frame)
    (let* ((p ((frame-coord-map frame) (make-vect 0 0)))
           (q ((frame-coord-map frame) (make-vect 1 1)))
           (fw (- (xcor-vect q) (xcor-vect p)))
           (fh (- (ycor-vect q) (ycor-vect p))))
      (emit "save();")
      (emit "translate(~a, ~a);" (* (xcor-vect p) *frame-scale*)
                                 (- *canvas-h* (* (ycor-vect q) *frame-scale*)))
      (emit "scale(~a, ~a);" fw fh)
      (emit (thunk))
      (emit "restore();"))))

;; js-painterpgm-file->painter
;; աEdge1xEdge2yʿԤʥե졼Τб
(define (pgm-file->painter file)
  (set! *image-file* file)
  (js-painter
   ;; FirefoxΥХк
   ;(format #f "drawImage(imgObj, 0, 0, ~a+1, ~a+1);"
   ;        *frame-scale* *frame-scale*)
   (format #f "drawImage(imgObj, 0, 0, ~a, ~a);" *frame-scale* *frame-scale*)))

(define alpha 1.0)

(define (pgm-file->painter2 file)
  (set! *image-file* file)
  (js-painter2
   (lambda ()
     (apply string-append
            (format #f "globalAlpha = ~a;~%" (let ((x alpha))
                                               (set! alpha (- alpha 0.002))
                                               x))
            ;; FirefoxΥХк
            ;(format #f "drawImage(imgObj, 0, 0, ~a+1, ~a+1);"
            ;        *frame-scale* *frame-scale*)
            (format #f "drawImage(imgObj, 0, 0, ~a, ~a);"
                    *frame-scale* *frame-scale*)
            '()))))

;;

(define frm3 (make-frame (make-vect 0 0)
                         (make-vect 0.8 0.3)
                         (make-vect 0.1 0.7)))

(define frm4 (make-frame (make-vect 0 0)
                         (make-vect 1 0)
                         (make-vect 0 0.5)))

(define frm5 (make-frame (make-vect 0 0)
                         (make-vect 0.5 0)
                         (make-vect 0 1)))

(make-canvas frm1)

(define sicp2 (pgm-file->painter2 "sicp.png"))

(define tri3
  (vects->painter (list (make-vect 0.0 0.0)
                        (make-vect 0.5 1.0)
                        (make-vect 1.0 0.0))
                  #f 0 "rgba(255, 0, 0, 0.7)"))

;; js-painterdeveloper.mozilla.org򸵤˺

(define curv (js-painter
"
    fillStyle = \"red\";
    beginPath();
    moveTo(30, 30);
    lineTo(480, 480);
    quadraticCurveTo(60, 70, 70, 480);
    lineTo(30, 30);
    fill();                                
"))

(define circ (js-painter
"
    var radgrad = createRadialGradient(150,150,30,170,170,90);
    radgrad.addColorStop(0, '#A7D30C');
    radgrad.addColorStop(0.9, '#019F62');
    radgrad.addColorStop(1, 'rgba(1,159,98,0)');
  
    var radgrad2 = createRadialGradient(355,355,60,376,400,150);
    radgrad2.addColorStop(0, '#FF5F98');
    radgrad2.addColorStop(0.75, '#FF0188');
    radgrad2.addColorStop(1, 'rgba(255,1,136,0)');

    var radgrad3 = createRadialGradient(285,45,45,306,60,120);
    radgrad3.addColorStop(0, '#00C9FF');
    radgrad3.addColorStop(0.8, '#00B5E2');
    radgrad3.addColorStop(1, 'rgba(0,201,255,0)');

    var radgrad4 = createRadialGradient(0,450,150,0,420,270);
    radgrad4.addColorStop(0, '#F4F201');
    radgrad4.addColorStop(0.8, '#E4C700');
    radgrad4.addColorStop(1, 'rgba(228,199,0,0)');
  
    fillStyle = radgrad4;
    fillRect(0,0,512,512);
    fillStyle = radgrad3;
    fillRect(0,0,512,512);
    fillStyle = radgrad2;
    fillRect(0,0,512,512);
    fillStyle = radgrad;
    fillRect(0,0,512,512);
"))

(define foo (beside curv (flip-vert curv)))
;(out (foo frm1))
;(out ((below foo foo) frm1))

;(out (circ frm1))
;(out ((square-limit circ 4) frm1))
